/*

*/

import renderer.scene.*;

/**
   The letter P defined using oriented Face primitives.
*/
public class P_F extends Model
{
   /**
      The letter P defined using oriented Face primitives.
   */
   public P_F()
   {
      super();

      Vertex v0 = new Vertex(0.00, 0.00,  0.0),  // front side
             v1 = new Vertex(0.00, 1.00,  0.0),
             v2 = new Vertex(0.75, 1.00,  0.0),
             v3 = new Vertex(1.00, 0.8,   0.0),
             v4 = new Vertex(1.00, 0.6,   0.0),
             v5 = new Vertex(0.75, 0.4,   0.0),
             v6 = new Vertex(0.25, 0.4,   0.0),
             v7 = new Vertex(0.25, 0.0,   0.0),

             v8  = new Vertex(0.25, 0.8,   0.0),
             v9  = new Vertex(0.75, 0.8,   0.0),
             v10 = new Vertex(0.75, 0.6,   0.0),
             v11 = new Vertex(0.25, 0.6,   0.0),


             v20 = new Vertex(0.00, 0.00, -0.25),  // back side
             v21 = new Vertex(0.00, 1.00, -0.25),
             v22 = new Vertex(0.75, 1.00, -0.25),
             v23 = new Vertex(1.00, 0.8,  -0.25),
             v24 = new Vertex(1.00, 0.6,  -0.25),
             v25 = new Vertex(0.75, 0.4,  -0.25),
             v26 = new Vertex(0.25, 0.4,  -0.25),
             v27 = new Vertex(0.25, 0.0,  -0.25),

             v28 = new Vertex(0.25, 0.8,  -0.25),
             v29 = new Vertex(0.75, 0.8,  -0.25),
             v30 = new Vertex(0.75, 0.6,  -0.25),
             v31 = new Vertex(0.25, 0.6,  -0.25);

      // front face
      addFace(v0, v7,  v6,  v5, v4, v3, v2, v1);
      addFace(v8, v11, v10, v9);

      // back face
      addFace(v20, v21, v22, v23, v24, v25, v26, v27);
      addFace(v28, v29, v30, v31);

      // around the outer faces
      addFace(v0,  v1, v21, v20);
      addFace(v1,  v2, v22, v21);
      addFace(v2,  v3, v23, v22);
      addFace(v3,  v4, v24, v23);
      addFace(v4,  v5, v25, v24);
      addFace(v5,  v6, v26, v25);
      addFace(v6,  v7, v27, v26);
      addFace(v7,  v0, v20, v27);

      // around the hole
      addFace(v8,  v11, v31, v28);
      addFace(v11, v10, v30, v31);
      addFace(v10, v9,  v29, v30);
      addFace(v9,  v8,  v28, v29);
   }
}
