/*

*/

import renderer.scene.*;

/**
   The letter P defined using oriented, solid Triangle primitives.
*/
public class P_T extends Model
{
   /**
      The letter P defined using Triangle primitives.
   */
   public P_T()
   {
      super();

      Vertex v0 = new Vertex(0.00, 0.00,  0.0),  // front side
             v1 = new Vertex(0.00, 1.00,  0.0),
             v2 = new Vertex(0.75, 1.00,  0.0),
             v3 = new Vertex(1.00, 0.8,   0.0),
             v4 = new Vertex(1.00, 0.6,   0.0),
             v5 = new Vertex(0.75, 0.4,   0.0),
             v6 = new Vertex(0.25, 0.4,   0.0),
             v7 = new Vertex(0.25, 0.0,   0.0),

             v8  = new Vertex(0.25, 0.8,   0.0),
             v9  = new Vertex(0.75, 0.8,   0.0),
             v10 = new Vertex(0.75, 0.6,   0.0),
             v11 = new Vertex(0.25, 0.6,   0.0),


             v20 = new Vertex(0.00, 0.00, -0.25),  // back side
             v21 = new Vertex(0.00, 1.00, -0.25),
             v22 = new Vertex(0.75, 1.00, -0.25),
             v23 = new Vertex(1.00, 0.8,  -0.25),
             v24 = new Vertex(1.00, 0.6,  -0.25),
             v25 = new Vertex(0.75, 0.4,  -0.25),
             v26 = new Vertex(0.25, 0.4,  -0.25),
             v27 = new Vertex(0.25, 0.0,  -0.25),

             v28 = new Vertex(0.25, 0.8,  -0.25),
             v29 = new Vertex(0.75, 0.8,  -0.25),
             v30 = new Vertex(0.75, 0.6,  -0.25),
             v31 = new Vertex(0.25, 0.6,  -0.25);


      // front face
      addTriangle(v0, v7,  v1);
      addTriangle(v7, v8,  v1);
      addTriangle(v1, v8,  v2);
      addTriangle(v2, v8,  v9);
      addTriangle(v2, v9,  v3);
      addTriangle(v3, v9,  v4);
      addTriangle(v4, v9,  v10);
      addTriangle(v4, v10, v5);
      addTriangle(v5, v10, v6);
      addTriangle(v6, v10, v11);

      // back face
      addTriangle(v21, v27, v20);
      addTriangle(v21, v28, v27);
      addTriangle(v22, v28, v21);
      addTriangle(v29, v28, v22);
      addTriangle(v23, v29, v22);
      addTriangle(v24, v29, v23);
      addTriangle(v30, v29, v24);
      addTriangle(v25, v30, v24);
      addTriangle(v26, v30, v25);
      addTriangle(v31, v30, v26);

      // around the outer faces
      addTriangle(v0,  v1,  v21);
      addTriangle(v0,  v21, v20);

      addTriangle(v1,  v2,  v22);
      addTriangle(v1,  v22, v21);

      addTriangle(v2,  v3,  v23);
      addTriangle(v2,  v23, v22);

      addTriangle(v3,  v4,  v24);
      addTriangle(v3,  v24, v23);

      addTriangle(v4,  v5,  v25);
      addTriangle(v4,  v25, v24);

      addTriangle(v5,  v6,  v26);
      addTriangle(v5,  v26, v25);

      addTriangle(v6,  v7,  v27);
      addTriangle(v6,  v27, v26);

      addTriangle(v7,  v0,  v20);
      addTriangle(v7,  v20, v27);

      // around the hole
      addTriangle(v8,  v11, v31);
      addTriangle(v8,  v31, v28);

      addTriangle(v11, v10, v30);
      addTriangle(v11, v30, v31);

      addTriangle(v10, v9,  v29);
      addTriangle(v10, v29, v30);

      addTriangle(v9,  v8,  v28);
      addTriangle(v9,  v28, v29);
   }
}
