/*

*/

import renderer.scene.*;
import renderer.pipeline.*;
import renderer.framebuffer.FrameBuffer;

import java.awt.Color;

/**

*/
public class TestMaze
{
   public static void main(String[] args)
   {
      // Create the Scene and Model objects that we shall render
      Scene scene = new Scene();

      // Set the Scene's viewport dimension
      int vp_width  = 1024;
      int vp_height = 512;
      FrameBuffer fb = new FrameBuffer(vp_width, vp_height);

      Model model = new Maze("maze1.txt");
      model.doBackfaceCulling = false;    /***** FIX THE ORIENTATIONS! ***/

      scene.addPosition(new Position(model));

      double fov    = 90.0;
      double aspect = 2.0;
      double near   = 1.0;
      double far    = 160.0;
      scene.camera.projPerspective(fov, aspect, near, far);
//    scene.camera.projOrtho(fov, aspect, near, far);

      // Middle of the maze, looking at the Mona Lisa.
      // (1)
      scene.camera.viewTranslate(80, 5, 80);
      scene.camera.viewRotate(180, 0, 1, 0);

      for (int t = 0; t < 360; t++)
      {
/*       // (2)
         double eyex = 80, eyey = 5, eyez = 80;
         double centerx = 80 + Math.sin(t*Math.PI/180),
                centery = 5,
                centerz = 80 + Math.cos(t*Math.PI/180);
         double upx=0, upy=1, upz=0;
         scene.camera.viewLookAt(eyex,    eyey,    eyez,    //camera position
                                 centerx, centery, centerz, //point camera is looking at
                                 upx,     upy,     upz);
*/
         // (1)
         scene.camera.viewRotate(1, 0, 1, 0);

         fb.clearFB(Color.black);
         Pipeline.render(scene, fb);
         fb.dumpFB2File(String.format("PPM_TestMaze%03d.ppm", t));
      }
   }
}
