/*

*/

package renderer.scene;

/**

*/
public class TexCoord
{
   public double s;
   public double t;

   /**
      Create a {@code TextCoord} object with the give texture coordinates.

      @param s  first texture coordinate
      @param t  second texture coordinate
   */
   public TexCoord(double s, double t)
   {
      this.s = s;
      this.t = t;
/*
      if ( (s < 0.0) || (s > 1.0)
        || (t < 0.0) || (t > 1.0) )
      {
         System.err.println("ERROR! Invalid texture coordinate for vertex");
         System.err.print( this.toString() );
         System.err.printf("<s,t> = <% .15f  % .15f>\n", s, t);
         Thread.dumpStack();
       //System.err.println(Arrays.toString(Thread.currentThread().getStackTrace()));
         System.exit(-1);
      }
*/
   }


   /**
      A "copy constructor". Construct a new {@code TexCoord}
      that is a copy of another {@code TexCoord}.

      @param tc  {@code TexCoord} to make a copy of
   */
   public TexCoord(TexCoord tc) // a "copy constructor"
   {
      this.s = tc.s;
      this.t = tc.t;
   }


   /**
      For debugging.

      @return {@link String} representation of this {@code TexCoord} object
   */
   @Override
   public String toString()
   {
      // Here is one way to get programmable precision.
      int p = 5; // the precision for the following format string
      String format = "(s, t) = (% ."+p+"f  % ."+p+"f)\n";
      return String.format(format, s, t);
   }
}
